<template>
  <b-modal
    :id="labelPrefix + 'Modal'"
    v-model="isOpen"
    :cancel-title="$t('Cancel')"
    header-class="no-overflow"
    :ok-disabled="validUrl === false || readonly || !requiredFieldsEntered"
    :ok-title="$t(okLabelKey)"
    :title="$t(labelPrefix + 'ModalTitle', { apName: applicationProfileLabel })"
    @cancel="close"
    @close="close"
    @hidden="hidden"
    @ok="save"
  >
    <StoreDescription
      v-if="
        labelPrefix === 'store' &&
        $options.components &&
        $options.components['StoreDescription']
      "
    />
    <div class="mandatory mb-2">
      <label
        :id="labelPrefix + 'Url' + 'Label'"
        class="form-label d-inline-flex gap-1 align-items-center"
        >{{ $t("url") }} <i-bi-question-circle-fill
      /></label>
      <b-form-input
        :id="labelPrefix + 'Url'"
        :disabled="readonly"
        :placeholder="$t('url')"
        :state="validUrl"
        trim
        :model-value="url.value"
        @update:modelValue="setUrl"
      />
      <b-tooltip
        :target="labelPrefix + 'Url' + 'Label'"
        triggers="hover"
        noninteractive
        >{{ $t("urlDescription") }}</b-tooltip
      >
      <b-form-invalid-feedback
        v-if="validForceUrl === false"
        :id="labelPrefix + 'UrlFeedback'"
      >
        <p>{{ $t("necessaryBaseUrl", { base_url: ap_base_url }) }}</p>
      </b-form-invalid-feedback>
    </div>

    <PropertyRenderer
      v-for="entry in visibleForm"
      :key="entry.predicate.value"
      :class="entry.required ? 'mandatory' : ''"
      :application-profile="applicationProfile"
      :definition="definition"
      :entry="entry"
      :readonly="readonly"
      :selected-property="applicationProfileBaseUrl"
      @updateProperty="setFormValue"
    />

    <div v-if="curation_process && labelPrefix === 'store'">
      <label
        :id="labelPrefix + 'State' + 'Label'"
        class="form-label d-inline-flex gap-1 align-items-center"
        >{{ $t("state") }} <i-bi-question-circle-fill
      /></label>
      <b-form-checkbox
        :id="labelPrefix + 'State'"
        :checked="applicationProfile.state === 1"
        :disabled="readonly"
        @update:modelValue="setState"
        >{{ $t("publish") }}</b-form-checkbox
      >
      <b-tooltip
        :target="labelPrefix + 'State' + 'Label'"
        triggers="hover"
        noninteractive
        >{{ $t("stateDescription") }}</b-tooltip
      >
    </div>
  </b-modal>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { NodeShapeProperty } from "@/types/shape-properties";
import type { Dataset, Quad_Object, Quad_Subject } from "@rdfjs/types";

import { defineComponent, type PropType, reactive } from "vue";

import {
  changeBaseUrl,
  editNodeShapeProperties,
  getApplicationProfileProperty,
  getApplicationProfileTargetClass,
  prefixes,
  updateNodeImport,
} from "@/util/linkedData";
import { isURI } from "@/util/uriCheck";

import serviceProvider from "@/util/service-providers/service-provider";
import {
  getDefaultLocaleValue,
  retrieveNodeShapeProperties,
} from "@/util/nodeShapeProperties";
import factory from "rdf-ext";
import State from "@/types/state";

import EmptyComponent from "@/components/Layout/EmptyComponent.vue";
const StoreDescription =
  serviceProvider.uiElements.StoreDescription ?? EmptyComponent;

export default defineComponent({
  name: "EditAP",
  components: {
    StoreDescription,
  },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    labelPrefix: {
      default: "edit",
      type: String,
    },
    okLabelKey: {
      default: "Continue",
      type: String,
    },
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
  },
  data() {
    return {
      ap_base_url: prefixes.aps,
      curation_process: serviceProvider.curation_process,
      url: factory.namedNode<string>(""),
      form: retrieveNodeShapeProperties(this.$i18n.availableLocales),
      isOpen: false,
    };
  },
  computed: {
    applicationProfileBaseUrl(): Quad_Subject {
      return factory.namedNode<string>(this.applicationProfile.base_url);
    },
    applicationProfileLabel(): string {
      const labelObject = this.form.find((entry) => entry.labelKey === "label");
      if (labelObject !== undefined && labelObject.localized) {
        return labelObject.value[this.$i18n.locale];
      }
      return "";
    },
    applicationProfileProperties(): Map<NodeShapeProperty, Quad_Object[]> {
      return new Map(
        this.form
          .filter((entry) => entry.labelKey !== "targetClass")
          .map((entry) => [
            entry,
            getApplicationProfileProperty(
              this.applicationProfile,
              this.definition,
              entry.predicate.value,
            ),
          ]),
      );
    },
    applicationProfileTargetClass(): string {
      return getApplicationProfileTargetClass(
        this.applicationProfile,
        this.definition,
      );
    },
    labelUrl(): string {
      return prefixes.dcterms + "title";
    },
    requiredFieldsEntered(): boolean {
      return this.form.every((entry) => !entry.required || entry.value);
    },
    validForceUrl(): boolean | null {
      if (serviceProvider.force_base_url) {
        return this.url.value.startsWith(this.ap_base_url);
      }
      return null;
    },
    validUrl(): boolean | null {
      if (!isURI(this.url.value)) {
        return false;
      }
      if (this.validForceUrl !== null) {
        return this.validForceUrl;
      }
      return null;
    },
    visibleForm(): NodeShapeProperty[] {
      return this.form.filter((entry) => !entry.hidden);
    },
  },
  watch: {
    "applicationProfile.base_url"() {
      this.url = factory.namedNode(this.applicationProfile.base_url);
    },
    applicationProfileProperties() {
      this.setByProperties();
    },
    applicationProfileTargetClass() {
      this.setFormPropertyValue(
        "targetClass",
        this.applicationProfileTargetClass,
      );
    },
    labelUrl() {
      this.setFormPropertyUrl("label", this.labelUrl);
    },
    open() {
      this.isOpen = this.open;
    },
  },
  methods: {
    close() {
      this.isOpen = false;
    },
    hidden() {
      this.setValues();
      this.$emit("close");
    },
    save() {
      editNodeShapeProperties(
        this.applicationProfile,
        this.definition,
        this.form,
        this.$i18n.locale,
      );
      changeBaseUrl(this.applicationProfile, this.definition, this.url.value);
      this.setImports();
      this.$emit("save");
    },
    setByProperties() {
      for (const [
        property,
        definitionValue,
      ] of this.applicationProfileProperties.entries()) {
        this.setFormPropertyValue(property.labelKey, definitionValue);
      }
    },
    setImports() {
      updateNodeImport(this.applicationProfile, this.definition);
    },
    setFormUrl(property: NodeShapeProperty, url: string) {
      property.predicate.value = url;
    },
    setFormValue(
      property: NodeShapeProperty,
      value: string | string[] | Quad_Object[],
      // eslint-disable-next-line @typescript-eslint/no-unused-vars
      sendUpdate = true,
      locale?: string,
    ) {
      if (Array.isArray(value)) {
        // Set Default Values
        if (property.localized) {
          property.value = reactive(
            getDefaultLocaleValue(this.$i18n.availableLocales),
          );
        } else if (property.type === "boolean") {
          property.value = false;
        } else if (property.type === "list") {
          property.value = [];
        } else {
          property.value = "";
        }
        for (const entry of value) {
          if (typeof entry !== "string") {
            if (property.localized) {
              if (entry.termType === "Literal") {
                property.value[entry.language] = entry.value;
              }
            } else {
              if (Array.isArray(property.value)) {
                property.value.push(entry.value);
              } else {
                property.value = entry.value;
              }
            }
          } else if (Array.isArray(property.value)) {
            property.value.push(entry);
          } else {
            property.value = entry;
          }
        }
      } else {
        if (property.localized && locale) {
          property.value[locale] = value;
        } else if (property.type === "list") {
          property.value = [value];
        } else {
          property.value = value;
        }
      }
    },
    setFormPropertyUrl(name: string, url: string) {
      const property = this.form.find(
        (formEntry) => formEntry.labelKey === name,
      );
      if (property !== undefined) {
        this.setFormUrl(property, url);
      }
    },
    setFormPropertyValue(
      name: string,
      value: string | string[] | Quad_Object[],
    ) {
      const property = this.form.find(
        (formEntry) => formEntry.labelKey === name,
      );
      if (property !== undefined) {
        this.setFormValue(property, value);
      }
    },
    setState(checked: boolean) {
      if (checked) {
        this.$emit("stateChange", State.PUBLISHED);
      } else {
        this.$emit("stateChange", State.DRAFT);
      }
    },
    setUrl(value: string) {
      this.url = factory.namedNode(value);
    },
    setValues() {
      this.setUrl(this.applicationProfile.base_url);
      this.setByProperties();
      this.setFormPropertyValue(
        "targetClass",
        this.applicationProfileTargetClass,
      );
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.mandatory :deep(label:after) {
  content: " *";
  color: var(--bs-form-invalid-color);
}
</style>
